/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

if(!dojo._hasResource["ibm.widget.NavButton"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.widget.NavButton"] = true;
dojo.provide("ibm.widget.NavButton");

dojo.require("dijit.form.RadioButton");

dojo.declare("ibm.widget.NavButton",
	dijit.form.RadioButton,
{
	baseClass: "dijitNavButton",
	lbl: "",

	templateString: dojo.cache("dijit.form", "templates/CheckBox.html", "<div class=\"dijitReset dijitInline\" waiRole=\"presentation\" style=\"width:98%;\"\n\t><input\n\t \t${nameAttrSetting} type=\"${type}\" ${checkedAttrSetting}\n\t\tclass=\"dijitReset dijitCheckBoxInput\"\n\t\tdojoAttachPoint=\"focusNode\"\n\t\n\><span class=\"dijitLabel\" dojoAttachEvent=\"onclick:_onClick\">${lbl}</span></div>\n"),

	constructor: function(keywordParameters){
		this.lbl = keywordParameters.lbl;
	},		
	
	_setCheckedAttr: function(/*Boolean*/ value){
		// If I am being checked then have to deselect currently checked radio button
		this.inherited(arguments);
		if(!this._created){ return; }
		if(value){
			var _this = this;
			// search for radio buttons with the same name that need to be unchecked
			dojo.query("INPUT[type=radio]", this.focusNode.form || dojo.doc).forEach( // can't use name= since dojo.query doesn't support [] in the name
				function(inputNode){
					if(inputNode.id != _this.id){
						var widget = dijit.getEnclosingWidget(inputNode);
						if(widget && widget.checked){
							widget.attr('checked', false);						
						}
					}
				}
			);
		}
	},

	_clicked: function(/*Event*/ e){
		if(!this.checked){
			this.attr('checked', true);
		}
	}
		
});

}
