
var utFeedWidgets = new Array();

function getWebFeed(url,loc,abstracts,max,dates,start,end,helpText,helpURL) {

	var widget = utFeedWidgets[url];

	if (widget==null)
	{
		widget = new FeedWidget({
			url: url,
			loc: loc,
			showAbstracts: abstracts,
			maxResults: max,
			showDate: dates,
			startDate: start,
			endDate: end,
			helpText: helpText,
			helpURL: helpURL
		});
		widget.createFeed();
		utFeedWidgets[url] = widget;
	}
	else
	{
		if (!widget.loading)
			widget.toggle();
	}
}

function getWebFeedHelp(url,loc,helpText,helpURL,abstracts,max,dates,start,end) {
	getWebFeed(url,loc,abstracts,max,dates,start,end,helpText,helpURL);
}

function FeedWidget(props){

	this.showAbstracts=props.showAbstracts;
	if (this.showAbstracts==null)
		this.showAbstracts = false;
	
	this.showDate=props.showDate;
	if (this.showDate==null)
		this.showDate = false;
		
	this.maxResults=props.maxResults;
	if (this.maxResults==null)
		this.maxResults = 5;
		
	this.url=props.url;
	this.loc = props.loc.parentNode;
	this.a = props.loc;
	
	this.startDate=props.startDate;
	this.endDate=props.endDate;
	
	this.baseURL = window.location.href;
	this.baseURL = this.baseURL.substring(0,this.baseURL.indexOf('topic'));
	
	this.helpText = props.helpText;
	this.helpURL = props.helpURL;
}

FeedWidget.prototype.createFeed = function()
{
	this.loading = true;
	this.displaySpinner(true);
	this.a.setAttribute("class","webfeed-link-open");

	if (window.XMLHttpRequest) { // Mozilla, Safari,...
		this.request = new XMLHttpRequest();
		if (this.request.overrideMimeType) {
	  		this.request.overrideMimeType('text/xml');
		}
	}else if (window.ActiveXObject) { // IE
        try {
        	this.request = new ActiveXObject("Msxml2.XMLHTTP");
      	} catch (e) {
        	try {
        		this.request = new ActiveXObject("Microsoft.XMLHTTP");
       		} catch (e) {}
      	}
    }
    this.request.feedWidget = this;
	this.request.onreadystatechange = this.load; 
	this.request.open('GET', this.baseURL+'com.ibm.ccl.feedreader.FeedService?'+this.url, true);
	this.request.send(null);
}


FeedWidget.prototype.load = function()
{
	// 'this' is now the 'request' object
	if (this.readyState == 4) {
	    if (this.status == 200 || this.status == 304) {
			this.feedWidget.displaySpinner(false);
			try{
		    	var dojo = eval('('+this.responseText+')');
		    	if (dojo.message!=null)
					this.feedWidget.writeError(dojo);
		    	else
			    	this.feedWidget.writeFeed(dojo);
			}catch(err){
				var dojo = new Object();
				dojo.message = 'The feed contained some unparsable characters';
				this.feedWidget.writeError(dojo);
			}
		}
	}
}

FeedWidget.prototype.writeFeed = function(dojo)
{
	var items = dojo.items;

	var parent = this.loc;
			
	var webfeedListDiv = document.createElement('div');	
	webfeedListDiv.setAttribute("class","webfeed-list-div");
	
	var ul = document.createElement("ul");
	ul.setAttribute("class","webfeed-link-list");
	
	var itemDisplayLimit = (items.length >= this.maxResults) ? this.maxResults : items.length;   //Limit item display list to $MaxFeedResults items
	
	for (var i=0;i<itemDisplayLimit;i++)
	{
		if ((this.startDate!=null && date<this.startDate) || (this.endDate!=null && date>this.endDate))
		{
			itemDisplayLimit = (items.length>=itemDisplayLimit+1) ? itemDisplayLimit+1 : items.length;
			break;
		}		
	
		var li  = document.createElement("li");
		
	    var a = document.createElement("a");
		a.style.textDecoration= 'none';
	   	a.setAttribute('target','_blank');
	   	a.setAttribute('href',items[i].link);
	   	
		var title = document.createTextNode(items[i].title);
		a.appendChild(title);	
	    li.appendChild(a);
	    
	    var date = convertDate(items[i].pubDate);
		if (this.showDate)
		{
			var dateDiv = document.createElement("div");
			dateDiv.style.position = 'relative';
			dateDiv.style.color = 'gray';
			dateDiv.style.bottom = '5px';
			dateDiv.style.fontSize = '.9em';
			dateDiv.style.lineHeight = '150%';
			
			var dateNode = document.createTextNode(date);
			dateDiv.appendChild(dateNode);
			li.appendChild(dateDiv);
		}
	    
	    
		if (this.showAbstracts && items[i].description!=null)
		{
			var abstractDiv = document.createElement("div");
			abstractDiv.setAttribute("class","utErrorDialogFeedAbstract");
			abstractDiv.appendChild(document.createTextNode(items[i].description));
			li.appendChild(abstractDiv);
		}	
		else if	(!this.showAbstracts && items[i].description!=null)
		{
			a.title = items[i].description;		
		}
			
		ul.appendChild(li);
	}
	
	var webfeedSubscribe = document.createElement("p");
	webfeedSubscribe.setAttribute("class","utErrorDialogFeedSubscribe");

	var aSubscribe = document.createElement("a");
	aSubscribe.setAttribute("target","_blank");	 
	aSubscribe.setAttribute("href",this.url);
	aSubscribe.appendChild(document.createTextNode("XML"));
				   
	webfeedSubscribe.appendChild(aSubscribe);
   
	webfeedListDiv.appendChild(ul);
	webfeedListDiv.appendChild(webfeedSubscribe);
	parent.appendChild(webfeedListDiv);
	this.loading = false;
}

FeedWidget.prototype.writeError = function(dojo)
{
    var DIVParent = this.loc;     //<div class="webfeed">
    var DIVResponse = document.createElement("div");
	DIVResponse.setAttribute("class","webfeed-list-div");
	DIVResponse.style.padding='10px';
		 
	var response= document.createElement("div");
	response.setAttribute("class","webfeed-error");
	      
	      
	if (dojo.eid!=null)
	{
		var eid = document.createElement("em");
		eid.appendChild(document.createTextNode(dojo.eid+': '));
		response.appendChild(eid);
	}
	
	
	var dojoDiv = document.createElement("div");
	dojoDiv.innerHTML = dojo.message;
    response.appendChild(dojoDiv);
    
    DIVResponse.appendChild(response);
	DIVParent.appendChild(DIVResponse);
	
	//Modifying class attribute on <a class="webfeed-link".. to <a class="webfeed-link-open" to indicate is open
     
    var para = document.createElement("p");
	para.style.marginBottom = '0px';
	
/*	if (dojo.help_text!=null)
	{
		var helpLink = document.createElement("a");
		helpLink.setAttribute("target","_blank");	 
    	helpLink.setAttribute("href",dojo.help_link);
    	helpLink.appendChild(document.createTextNode(dojo.help_text));
    	para.appendChild(helpLink);
	}	   
*/	if (this.helpText!=null)
	{
		var helpLink = document.createElement("a");
		helpLink.setAttribute("target","_blank");	 
    	helpLink.setAttribute("href",this.helpURL);
    	helpLink.appendChild(document.createTextNode(this.helpText));
    	para.appendChild(helpLink);
	}	   
   
	DIVResponse.appendChild(response);
	DIVResponse.appendChild(para);
    DIVParent.appendChild(DIVResponse);

	this.loc.setAttribute("class","webfeed-link-open"); 	   
//	this.loc.style.backgroundImage= 'url(' + this.baseURL + "com.ibm.ccl.feedreader/images/widget-open-rollover.gif" +  ')';
	this.loading = false;
	
			 
}

FeedWidget.prototype.displaySpinner = function(show)
{
	if (show)
		this.loc.parentNode.setAttribute("class","webfeed-spin");
	else
		this.loc.parentNode.setAttribute("class","webfeed");
	
}
	
FeedWidget.prototype.toggle = function()
{
	var webfeedListDiv;
	
	for (var c=0;c<this.loc.childNodes.length;c++){
		if (this.loc.childNodes[c].className=="webfeed-list-div"){
			webfeedListDiv = this.loc.childNodes[c];
			break;
		}
	}
	if (webfeedListDiv==null)
		return;
	
	var show = webfeedListDiv.style.display=='none';
	
	if (show){
		webfeedListDiv.style.display='block';
		this.a.setAttribute("class","webfeed-link-open");
	}else{
		webfeedListDiv.style.display='none';
		this.a.setAttribute("class","webfeed-link");
	}

}

function convertDate(dateStr)
{
	if (dateStr==null)
		return new Date();
	var date = new Date(dateStr);
	return date
}