



// ==========================================================================
//  GLOBAL VARIABLES  
// ==========================================================================

/* List of feature categories for uninstall */
var SelectedInstalledEntries = new dojox.collections.ArrayList();

/* List of feature categories for updates */
var SelectedUpdateCtgrsEntries = new dojox.collections.ArrayList();

/* List of selected local sites */
var SelectedLocalEntries = new dojox.collections.ArrayList();

/* List of feature categories selected for install */
var SelectedCategoriesEntries = new dojox.collections.ArrayList();

var FEATURE_TYPE = '';
var INSTALL_FEATURE_TYPE = 'InstallCategories';
var REMOVE_FEATURE_TYPE = 'RemoveCategories';
var UPDATE_FEATURE_TYPE = 'InstallUpdates';
var UPLOAD_FEATURE_TYPE = 'UploadSite';
var CATEGORIES_STRING = '';
var IS_OPERATION_START_FAILED = false;

var FEATURE_TYPE_XID = '';


var CURRENT_FILTER_STATE = ALL_SITES;

// Handle cancellation of Updating, Removing & Installing features
var IS_TASK_IN_PROGRESS = false;
var IS_RUN_IN_BCKGRND = false;

var IS_CANCEL_INSTALL = false;

var TIMER = null;
var RESIZE_TIMER = null;
var ROOT_TREE_STORE_ITEMS = null;
var IS_VIEW_EDIT_MODE = false;
var VIEW_SITE_NAME = '';
var VIEW_SITE_PATH = '';
var VIEW_SITE_TYPE = '';

var IS_EDIT_SITE_DISABLED = true;
var IS_REMOVE_SITES_DISABLED = true;
var IS_INSTALL_DISABLED = true;
var IS_REMOVE_DISABLED = true;
var IS_UPDATE_DISABLED = true;

var POPUP_MENU_SELECTED_ITEM = null;
var POPUP_MENU_SELECTED_TREENODE = null;

//Track Last Update clicked
lastUpdateCategoryName='';
lastUpdateItemLink='';
lastUpdateItemDependency='';
lastUpdateTokenString='';

// Handle Favorites...
var FAVORITE_REQUEST = '';

var OK_CANCEL 		= 0;
var YES_NO 			= 1;
var RETRY_CANCEL 	= 2;

var IS_SHOW_PROGRESS_STATUS = false;

var optionsDialog = null;

var I18N_Obj;

// ==========================================================================
//  END GLOBAL VARIABLES  
// ==========================================================================

function init()
{
	I18N_Obj = dojo.i18n.getLocalization("translations", "updater_strings");
	
	initFilterOptions();
	
	initGridContextMenu();
	
	initAddSitesDialog();
	
	dojo.connect(dijit.byId('progressDialog'), "hide", handleProgressDialogClose);
	dojo.connect(dijit.byId('warningMsgDialog'), "hide", handleWarningDialogClose);
	
	dojo.connect(dijit.byId('tree'), "onClick", function(e){   
		
    	var treeItem = e.i;
    	var itemType = treeItem.type;
    	var itemInstalled = treeItem.installed;
    	var itemUpdate = treeItem.update;
    	var itemLink = treeItem.link;
    	var categoryName = treeItem.title;
    	var itemDependency = treeItem.dependency;
    	var itemTokenString = itemLink + '$' + categoryName + '$' + itemDependency;
    	
    	var previousUpdateEntry="";
    	var previousUpdateIndex=-1;
    	
    	if(itemTokenString!=lastUpdateTokenString)
    	{
    		previousUpdateIndex = SelectedCategoriesEntries.indexOf(previousUpdateEntry);
    		
    		if(previousUpdateIndex!=-1)
    		{
    			SelectedCategoriesEntries.removeAt(previousUpdateIndex);
    		}
    			
    		if(itemType=="category" && itemInstalled=="true" && itemUpdate=="true")
	    	{
	    		SelectedCategoriesEntries.add(itemLink + '$' + categoryName + '$' + itemDependency);
	
	    		setAttribute('downloadButton', 'disabled', false);
	    	}
	    	else
	    	{
	    		setAttribute('downloadButton', 'disabled', true);
	    	}
    		
    		lastUpdateCategoryName=categoryName;
			lastUpdateItemLink=itemLink;
			lastUpdateItemDependency=itemDependency;
			lastUpdateTokenString = itemTokenString;
	    	
    	}
      
	});
	
	var wipeArgs = {
		node: "runinbckgrndPane"
	};
	dojo.fx.wipeOut(wipeArgs).play();
	
	dojo.byId("chkShowStatusPane").style.visibility = 'hidden';
	
	updateButtons();
					
	initTreeContextMenu();
	
	attachTreeEvent();
	
	var userAgent = navigator.userAgent;
			
//	updateInstalledFeatureGrid('false');
}


function formatCheckBox(value) {

	if (value=='(No_content_installed)')
		return '';

	var id = 'I-'+value;
	var check = dijit.byId(id);
	if (check)
		check.destroy();

	check = new dijit.form.CheckBox({
		name: id,
		id: id,
		onClick: function(){handleCheckboxAction(value);}
	});
	return check;
}

function formatUpdateImg(value) {

	if (value=='(No_content_installed)')
		return '';
	if (value == "true") {
		return '<span class="UA_Icons categoryUpdateIcon"></span>';
	} else {
		return '<span class="UA_Icons categoryIcon"></span>';
	}
}

// Format string with replacement variables
function format(str) {
	
	for(i = 1; i < arguments.length; i++) {
		str = str.replace("{" + (i - 1) + "}", arguments[i]);
	}
	return str;
}

function setAttribute(dijitId, property, value) {
	
	var dijitObject = dijit.byId(dijitId);
	if (dijitObject)
		dijitObject.attr(property, value);
}

function setAttributeObj(dijitObject, property, value) {
	
	if (dijitObject)
		dijitObject.attr(property, value);
}

function setNodeAttribute(nodeId, property, value) {
	
	dojo.attr(nodeId, property, value);
}

function setContent(contentId, content) {
	
	setAttribute(contentId, 'content', content);
	//dojo.query("#" + contentId).html(content);
}

function updateButtons() {
	
	setAttribute('removeButton', 'disabled', true);
	installedGridStore.fetch({
		query:{title:"*"},
		onItem: function(item) {
			var boxCheck = dijit.byId('I-'+item.uid[0]);
			if (boxCheck!=null && boxCheck.checked==true)
				setAttribute('removeButton', 'disabled', false);
		}
	});
	
	setAttribute('editSiteButton', 'disabled', IS_EDIT_SITE_DISABLED);
	setAttribute('removeSiteButton', 'disabled', IS_REMOVE_SITES_DISABLED);
	setAttribute('downloadButton', 'disabled', IS_INSTALL_DISABLED);
	setAttribute('updateButton', 'disabled', IS_UPDATE_DISABLED);
}

function isInstallOrRemoveInProgress() {
	
	var isRunning = IS_TASK_IN_PROGRESS;
	
	if (isRunning == true) {
		var msg = installInProgress_msg;
		if (FEATURE_TYPE == REMOVE_FEATURE_TYPE)
			msg = removeInProgress_msg;
		else if (FEATURE_TYPE == UPDATE_FEATURE_TYPE)
			msg = updateInProgress_msg;
		
		alertWithTitle(msg, waitlbl_msg);
	}
	
	return isRunning;
}

function handleSingleInstallAction() {
	
	if (isInstallOrRemoveInProgress() == true) return;
	
	FEATURE_TYPE = INSTALL_FEATURE_TYPE;
	
	var id = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'uid');	
	var label = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'title');
	var dependencyList = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'dependency');
	
	var dependency = checkInstallDependency(label, dependencyList, false, POPUP_MENU_SELECTED_TREENODE, false);

	CATEGORIES_STRING = id.replace(/ /g, "_");
	if (dependency!="")
		CATEGORIES_STRING+=","+id.substring(0,id.lastIndexOf("->")+2)+dependency.replace(/ /g, "_");
	
	showOperationProgress();

}

function handleInstallAction() {

	if (isInstallOrRemoveInProgress() == true) 
		return;

	FEATURE_TYPE = INSTALL_FEATURE_TYPE;

	var categoriesToInstall = "";
	var dependencyList = "";
	
	var tree = dijit.byId("tree");
	var boxes = tree.getCheckedBoxes();
	for (var b=0;b<boxes.length;b++){
		var uid = boxes[b].id.substring(0,boxes[b].id.lastIndexOf("->"));
		favoriteAdded(uid,boxes[b].link+"/site.xml");
		categoriesToInstall+=boxes[b].id;
		if (b<boxes.length-1)
			categoriesToInstall+=",";
	}
	
	CATEGORIES_STRING = categoriesToInstall;

	tree.clearCheckedBoxes();
	
	checkDependencyAndProceed(dependencyList, true);
}

function checkDependencyAndProceed(dependencyList, isInstall) {
	
	if (dependencyList != "") {
		
		var dependencyContent = '';
		if (isInstall == true)
			dependencyContent = format(warningInstallDependencyCategory_msg, dependencyList);
		else
			dependencyContent = format(warningRemoveDependencyCategory_msg, dependencyList);
		
		//Show dependency alert
//		dijit.byId('dependencyContent').setContent(dependencyContent);
		setContent('dependencyContent', dependencyContent);
		
	} else {
		if (isInstall == true)
			showOperationProgress();
		else {
			var msg = warningRemoveCategory_msg;
			alertWarningType(msg, YES_NO);
		}
	}
}

function handleSingleRemoveAction() {
	
	var label = POPUP_MENU_SELECTED_ITEM.title[0];
	var dependencyList = POPUP_MENU_SELECTED_ITEM.dependent[0];
	
	doHandleSingleRemoveAction(label, dependencyList);
}

function handleSingleRemoveTreeAction() {
	
	var label = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'title');
	var dependencyList = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'dependency');
	
	doHandleSingleRemoveAction(label, dependencyList);
}

function doHandleSingleRemoveAction(label, dependencyList) {
	
	if (isInstallOrRemoveInProgress() == true) {
		return;
	}
	
	if (label == null) {
		// If this condition is true, then check the calling method properly...
		return;
	}
	
	if (dependencyList == null) {
		dependencyList = '';
	}
	
	var dependency = checkRemoveDependency(label, dependencyList, false, false);
	
	if (dependency != "")
		CATEGORIES_STRING = dependency + ',' + label;
	else
		CATEGORIES_STRING = label;
	
	FEATURE_TYPE = REMOVE_FEATURE_TYPE;
	
	checkDependencyAndProceed(dependency, false);
}

function handleRemoveAction() {

	CATEGORIES_STRING = "";
	FEATURE_TYPE = REMOVE_FEATURE_TYPE;
	
	for (var i=0;i<installedGridStore._arrayOfAllItems.length;i++)
	{
	    for(var j=0;j<SelectedInstalledEntries.count;j++)
	    {
	        var installedEntry = SelectedInstalledEntries.item(j);
		    var entryName = installedEntry.split('$');
	
	        if(installedGridStore._arrayOfAllItems[i].title[0] == entryName[0])
	        {
		      CATEGORIES_STRING+=installedGridStore._arrayOfAllItems[i].title[0];
		
		      if (i+1<installedGridStore._arrayOfAllItems.length)
			     CATEGORIES_STRING+=",";
	        }
	     }
	}
	
	SelectedInstalledEntries.clear();
	checkDependencyAndProceed("", false);
}

function validateDependencyList(dependencyList, dependency) {
	
	var found = false;
	var tokens = dependencyList.split(',');
	
	for (var i=0; i<tokens.length; i++) {
		
		if (tokens[i] == dependency) {
			found = true;
			break;
		}
	}
	
	return found;
}

function doRemoveAction() {
	
	showOperationProgress();
}

function handleSingleUpdateAction() {
	
	if (isInstallOrRemoveInProgress() == true) return;
	
	FEATURE_TYPE = UPDATE_FEATURE_TYPE;
	
	CATEGORIES_STRING = POPUP_MENU_SELECTED_ITEM.title[0];
	
	showOperationProgress();
}

function handleUpdateAction() {
	
	// If no selected installed categories for remove, the do nothing...
	if (SelectedUpdateCtgrsEntries.count <= 0) return;
	
	if (isInstallOrRemoveInProgress() == true) return;
	
	FEATURE_TYPE = UPDATE_FEATURE_TYPE;
	
	var categoriesToUpdate = "";
	
	for (var i=0; i < SelectedUpdateCtgrsEntries.count; i++) {
		
		var itemTitle = SelectedUpdateCtgrsEntries.item(i);
		
		if (categoriesToUpdate == "")
			categoriesToUpdate = itemTitle;
		else
			categoriesToUpdate += ',' + itemTitle;
	}
	
	CATEGORIES_STRING = categoriesToUpdate;
	
	showOperationProgress();
}

function showOperationProgress(xid) {
	
	if (xid==null)
		xid = guid();
	FEATURE_TYPE_XID = xid;
	
	doResetProgressDialog();
	
	if (IS_TASK_IN_PROGRESS == true) return;
	
	//First thing. Show the progress bar and indicate that 
	//categories list is being sent to server
	dijit.byId('progressDialog').show();
	removeProgressDlgButton();
	dojo.byId("progressbar").style.visibility = 'visible';
	progressbar.update({indeterminate: true});
	if (FEATURE_TYPE == INSTALL_FEATURE_TYPE)
		setProgressStatusbar(prepareInstalllbl_msg);
	else if (FEATURE_TYPE == REMOVE_FEATURE_TYPE)
		setProgressStatusbar(prepareUninstalllbl_msg);
	else if (FEATURE_TYPE == UPDATE_FEATURE_TYPE)
		setProgressStatusbar(prepareInstallUpdatelbl_msg);
	else if (FEATURE_TYPE == UPLOAD_FEATURE_TYPE)
		setProgressStatusbar(prepareInstallUpdatelbl_msg);
	
	doOperation();
}

function doOperation() {
	
	if (IS_TASK_IN_PROGRESS == true) return;
	
	
	if (FEATURE_TYPE!=UPLOAD_FEATURE_TYPE)
	{
		dojo.xhrGet({
			url: 'config',
			handleAs: "text",
			content: {
				op: FEATURE_TYPE,
				categoryString: CATEGORIES_STRING,
				xid: FEATURE_TYPE_XID,
				lang: LANG
			},
			load: function(data, ioArgs) {
				if (data.indexOf('"message":')>-1)
				{				
					data = dojo.fromJson(data);
					operationFailed(data);
				}			
				else
					operationComplete(data, false);
			},
			error: function(data, ioArgs) {
				
				var msg = installfailedmsg_msg;
				if (FEATURE_TYPE == REMOVE_FEATURE_TYPE)
					msg = warningRemoveStartFailed_msg;
				else if (FEATURE_TYPE == UPDATE_FEATURE_TYPE)
					msg = installfailedmsg_msg;
				
//				alert(msg);
				return;
			}
		});
	}
	
	startProgressMonitor();
}

function operationFailed(json) {
	
	IS_TASK_IN_PROGRESS = false;
	IS_CANCEL_INSTALL = false;
	FEATURE_TYPE_XID = '';
	IS_OPERATION_START_FAILED = true;
	doHideProgressDialog();
			
	var content = json.eid!='' ? '<em>'+json.eid+'</em>: ' : '';
	var error = dijit.byId('errorDialog');
	if (error)
		error.destroy();
	error = new ibm.widget.ErrorDialog({
		id: 'errorDialog',
		style:'width:700px;',
		title: ERROR,
		eid: json.eid,
		content: content + json.message,
		stack: json.stack,
		helpHref: json.helpHref,
		helpTitle: json.helpTitle,
		searchCriteria: json.eid+' '+json.message
	});
	error.show();
}

function operationComplete(data, isError) {
	
	dojo.byId("chkShowStatusPane").style.visibility = 'hidden';
	
	var isCanceled = (data == 'Canceled' || data.indexOf('Status CANCEL') == 0);
	var isNetworkFailed = (data.indexOf('No route to host: connect') >= 0);
	if (isError == false && isNetworkFailed == false)
		isError = (!isCanceled) ? (data != '') : false;
	
	var statusMsg = INSTALL_COMPLETE;
	if (isNetworkFailed == true)
		statusMsg = warningInstallNetworkFailed_msg;
	else if (isError == true)
		statusMsg = installfailedmsg_msg + ": " + data;
	
	if (IS_CANCEL_INSTALL == true) {
		statusMsg = installCanceled_msg;
	}
	else if (FEATURE_TYPE == REMOVE_FEATURE_TYPE) {
		statusMsg = removeCompleted_msg;
		if (isNetworkFailed == true)
			statusMsg = warningRemoveNetworkFailed_msg;
		else if (isError == true)
			statusMsg = format(removeFailed_msg, data);
	}
	else if (FEATURE_TYPE == UPDATE_FEATURE_TYPE) {
		statusMsg = updateCompleted_msg;
		if (isNetworkFailed == true)
			statusMsg = warningUpdateNetworkFailed_msg;
		else if (isError == true)
			statusMsg = format(updateFailed_msg, data);
	}
	else if (FEATURE_TYPE == UPLOAD_FEATURE_TYPE) {
		statusMsg = updateCompleted_msg;
		if (isNetworkFailed == true)
			statusMsg = warningUpdateNetworkFailed_msg;
		else if (isError == true)
			statusMsg = errorConnectmsg_msg+"."+data;
	}
	
	if (isNetworkFailed == true || isError == true) {
		operationFailed(dojo.fromJson(data));
		return;
	}
	
	CATEGORIES_STRING = '';
	onOperationComplete(statusMsg);
}

function startProgressMonitor() {
	
	// Install/remove operation started...
	IS_TASK_IN_PROGRESS = true;
	
    /* Update Counter & progress bar */
	progressbar.update({indeterminate: false});
    progressbar.update({ maximum: 100, progress: 0 });
    var wipeArgs = {
		node: "runinbckgrndPane"
	};
	dojo.fx.wipeOut(wipeArgs).play();
    runinbckgrndProgressbar.update({indeterminate: false});
    runinbckgrndProgressbar.update({ maximum: 100, progress: 0 });

    var innerHTML = '';
    var statusMsg = '';
	IS_RUN_IN_BCKGRND = false;
	if (FEATURE_TYPE == INSTALL_FEATURE_TYPE) {
		innerHTML = 
        	'<button onclick="runInstallInBckgrnd()" dojoType="dijit.form.Button" type="submit">' 
        	+ runinbckgrndlbl_msg + '</button>' 
        	+ '<button onclick="dijit.byId("progressDialog").hide()" dojoType="dijit.form.Button" type="submit" iconClass="mailIconCancel">' 
        	+ cancellbl_msg + '</button>';
		statusMsg = installfeatures_msg;
	} else {
        innerHTML = 
        	'<button onclick="dijit.byId("progressDialog").hide()" dojoType="dijit.form.Button" type="submit">' 
        	+ runinbckgrndlbl_msg + '</button>';
        statusMsg = uninstallfeatures_msg;
        if (FEATURE_TYPE == UPDATE_FEATURE_TYPE)
        	statusMsg = updatefeatures_msg;
	}
	
	addProgressDlgButton(innerHTML);
	
	setProgressStatusbar(statusMsg + '<br/><br/>');
	setRunInBckgrndProgressStatusbar(statusMsg);
	
	dojo.byId("chkShowStatusPane").style.visibility = 'visible';
	
	TIMER = setTimeout("updateProgressStatus()", 3000);
}

function S4()
{
	return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
}

function guid()
{
	return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
}


function updateLocalEntry(siteName, siteFile, updateSite) {
	
	saveLocalSites(siteName, siteFile, "", siteName,updateSite, "update");
}





/**************************************************************
 * Refreshes the content of the available features for the currently selected site
 * internal or remote
 **************************************************************/
function updateInstalledFeatureGrid(checkUpdates) {
	installedGridStore.fetch({
		query:{uid:'*'},
		onItem:function(item){
			var id = 'I-'+item.title[0].replace(/ /g, "_");
			var chk = dijit.byId(id);
			if (chk)
				chk.destroy();
		},
		onComplete:function(){
		    installedGridStore.close();
		    installedGridStore.fetch();
		    installedGrid.setStore(installedGridStore, { uid: '*' });   
		    updateButtons();		
		}
	});
}

function refreshTree() {
	
	var tree = dijit.byId("tree");
	if (tree) {
		dojo.byId("treeContainer").removeChild(tree.domNode);
		tree.destroy();
		ROOT_TREE_STORE_ITEMS = null;
	}
	
	resetAvailableArrayList();
	
	var filter = dijit.byId('siteSelector').attr('value');
	
	var url = "config?op=SiteInfo&filter=" + filter;
	
	var treeStore = new ibm.DynamicReadStore({jsId: "sitesTreeStore", url: url});
	
	var treeModel = new ibm.DynamicTreeModel({
		store: treeStore,
//		showRoot: false,
		jsId: sitesTreeModel
	});
	
	var newTree = new ibm.widget.CheckTree({
		model: treeModel,
		showRoot: false,
		persist:false,
		style: "width:100%;border-left:10px",
		isExpanded: "false",
		label:"Site List",
		id: "tree",
		jsId: "tree"
	});

	dojo.byId("treeContainer").appendChild(newTree.domNode);
	
	newTree.startup();
	
	initTreeContextMenu();
	
	attachTreeEvent();
	
	lastUpdateCategoryName='';
	lastUpdateItemLink='';
	lastUpdateItemDependency='';
	lastUpdateTokenString='';
	
	dojo.connect(dijit.byId('tree'), "onClick", function(e){   
		
    	var treeItem = e.i;
    	var itemType = treeItem.type;
    	var itemInstalled = treeItem.installed;
    	var itemUpdate = treeItem.update;
    	var itemLink = treeItem.link;
    	var categoryName = treeItem.title;
    	var itemDependency = treeItem.dependency;
    	var itemTokenString = itemLink + '$' + categoryName + '$' + itemDependency;
    	
    	var previousUpdateEntry="";
    	var previousUpdateIndex=-1;
    	
    	if(itemTokenString!=lastUpdateTokenString)
    	{
    		previousUpdateIndex = SelectedCategoriesEntries.indexOf(previousUpdateEntry);
    		
    		if(previousUpdateIndex!=-1)
    		{
    			SelectedCategoriesEntries.removeAt(previousUpdateIndex);
    		}
    			
    		if(itemType=="category" && itemInstalled=="true" && itemUpdate=="true")
	    	{
	    		SelectedCategoriesEntries.add(itemLink + '$' + categoryName + '$' + itemDependency);
	    		
	    		setAttribute('downloadButton', 'disabled', false);
	    	}
	    	else
	    	{
	    		setAttribute('downloadButton', 'disabled', true);
	    	}
    		
    		lastUpdateCategoryName=categoryName;
			lastUpdateItemLink=itemLink;
			lastUpdateItemDependency=itemDependency;
			lastUpdateTokenString = itemTokenString;
	    	
    	}
      
	});
}

function attachTreeEvent() {
	
	var tree = dijit.byId("tree");
	if (!tree) return;
	
	tree.onNodeFocusEvent = function(treeNode) {
		treeDataSelection(treeNode.item);
		updateButtons();
	};
}

function treeDataSelection(item) {
	
	SelectedLocalEntries.clear();
	
	// Disable edit button
	IS_EDIT_SITE_DISABLED = true;
	
	// Disable remove button
	IS_REMOVE_SITES_DISABLED = true;
	
	var type = getValue(item, 'type');
	if (type != 'localsite')
		return;
	
	// If localsite is selected...
	var link = getValue(item, 'link');
	var id = getValue(item, 'uid');
	
	SelectedLocalEntries.add(link + ',' + id);
	
	// Enable edit button
	IS_EDIT_SITE_DISABLED = false;
	
	// Enable remove button
	IS_REMOVE_SITES_DISABLED = false;
}

function resetAvailableArrayList() {
	
	SelectedCategoriesEntries.clear();
	SelectedLocalEntries.clear();
	
	IS_EDIT_SITE_DISABLED = true;
	IS_REMOVE_SITES_DISABLED = true;
	IS_INSTALL_DISABLED = true;
	updateButtons();
}

function alertError(msg) {
	alertWithTitle(msg,messageerrorlbl_msg);
}

function alertWithTitle(msg, title) {
	var errDetails = document.getElementById("errorDetails");
	errDetails.style.display="none";
	var button = dijit.byId('errorDetailsButton');
	dijit.byId('errorMsgDialog').titleNode.innerHTML = title;
	dijit.byId('errorMsgDialog').show();
	
	if (msg.indexOf("\n")>-1)
	{
		setAttribute('errorMsg', 'content', msg.substring(0,msg.indexOf('\n')));
		setAttribute('errorDetails', 'content', msg.substring(msg.indexOf('\n')+1));
		button.setAttribute('disabled', false);
	}
	else if (msg.indexOf("<br/>")>-1)
	{
		setAttribute('errorMsg', 'content', msg.substring(0,msg.indexOf('<br/>')));
		setAttribute('errorDetails', 'content', msg.substring(msg.indexOf('<br/>')+5));
		button.setAttribute('disabled', false);
	}
	else
	{
		setAttribute('errorMsg', 'content', msg);
		button.setAttribute('disabled', true);
	}
	
}

function alertWarning(msg) {
	
	alertWarningType(msg, OK_CANCEL);
}

function alertWarningType(msg, buttonType) {
//	dijit.byId('warningMsg').setContent('' + msg);
	setContent('warningMsg', '' + msg);
	
	var okLabel = '';
	var cancelLabel = '';
	if (buttonType == YES_NO) {
		okLabel = YES;
		cancelLabel = NO;
	} else if (buttonType == RETRY_CANCEL) {
		okLabel = RETRY;
		cancelLabel = cancellbl_msg;
	} else {
		okLabel = oklbl_msg;
		cancelLabel = cancellbl_msg;
	}
	
	setAttribute('warningMsgOKButton', 'label', okLabel);
	setAttribute('warningMsgCancelButton', 'label', cancelLabel);
	
	setAttribute('warningMsgOKButton', 'disabled', false);
	setAttribute('warningMsgCancelButton', 'disabled', false);
	
	dijit.byId('warningMsgDialog').show();
}

var IS_WARNING_DIALOG_PRESSED_OK = false;
function handleWarningDialogOK() {
	
	IS_WARNING_DIALOG_PRESSED_OK = true;
	dijit.byId('warningMsgDialog').hide();
	
	if (FAVORITE_REQUEST == 'add') {
		favoriteAdded();
	}
	else if (FAVORITE_REQUEST == 'remove') {
		favoriteRemoved();
	} else if (IS_OPERATION_START_FAILED == true) {
		// Could not start install/remove operation...
		// Try again...
		IS_OPERATION_START_FAILED = false;
		showOperationProgress();
		
	} else if (IS_TASK_IN_PROGRESS == true) {
		// Cancel the current install operation...
		// Need to read the TIMER status and then start the cancel operation for install...
		
		doResetProgressDialog();
		
		dijit.byId('progressDialog').show();
		removeProgressDlgButton();
		progressbar.update({indeterminate: true});
		setProgressStatusbar(infoCancelInProgress_msg);
		
		doCancelCurrentOperation();
		
	} else if (FEATURE_TYPE == REMOVE_FEATURE_TYPE) {
		// Start remove operation...
		doRemoveAction();
	}
}

function handleWarningDialogClose() {
	
	// If OK button pressed...
	if (IS_WARNING_DIALOG_PRESSED_OK == true) {
		IS_WARNING_DIALOG_PRESSED_OK = false;
		return;
	}
	
	// Else if Cancel button pressed...
	
	if (FAVORITE_REQUEST != '') {
		FAVORITE_REQUEST = '';
	} else if (IS_OPERATION_START_FAILED == true) {
		// Could not start install/remove operation...
		IS_OPERATION_START_FAILED = false;
		FEATURE_TYPE = '';
		CATEGORIES_STRING = '';
		
	} else if (IS_TASK_IN_PROGRESS == true) {
		// Cancel of current install message cancelled...
		// Display the progress dialog again...
		dijit.byId('progressDialog').show();
		
	} else if (FEATURE_TYPE == REMOVE_FEATURE_TYPE) {
		// Do not start remove operation...
		FEATURE_TYPE = '';
		CATEGORIES_STRING = '';
	}
}

function handleLocalRadioMouseOver() {
	
}

function resizePage() {
	
	placeButtonsAtCenter();
	
	if (RESIZE_TIMER) {
		clearTimeout(RESIZE_TIMER);
		RESIZE_TIMER = null;
	}
//	RESIZE_TIMER = setTimeout("resizeInstalledGrid()", 100);
}

function placeButtonsAtCenter() {
	/*if (document.getElementById) {
		var windowHeight = document.getElementById('availableContentContainer').offsetHeight - 70;
		if (windowHeight > 0) {
			var contentElement = document.getElementById('buttonContainer');
			var contentHeight = contentElement.offsetHeight;
			if (windowHeight - contentHeight > 0) {
				contentElement.style.position = 'relative';
				contentElement.style.top = ((windowHeight / 2) - (contentHeight / 2)) + 'px';
			}
			else {
				contentElement.style.position = 'static';
			}
		}
	}*/
}

function getWindowHeight() {
	var windowHeight = 0;
	if (typeof(window.innerHeight) == 'number') {
		windowHeight = window.innerHeight;
	}
	else {
		if (document.documentElement && document.documentElement.clientHeight) {
			windowHeight = document.documentElement.clientHeight;
		}
		else {
			if (document.body && document.body.clientHeight) {
				windowHeight = document.body.clientHeight;
			}
		}
	}
	return windowHeight;
}

function handleCheckboxAction(itemUID) {
	
	//SelectedInstalledEntries.clear();
	var boxChecked = dijit.byId('I-'+itemUID);
	
	installedGridStore.fetchItemByIdentity({
		identity: itemUID,
		onItem: function(item) {
			
			var itemUpdate = installedGridStore.getValue(item, "update");
			var itemTitle = installedGridStore.getValue(item, "title");
			
			var dependent = installedGridStore.getValue(item, "dependent");
			if (dependent!=null)
			{
				var dChk = dijit.byId('I-'+dependent.replace(/ /g, "_"));
				if (dChk!=null)
				{
					setAttributeObj(dChk, 'disabled', boxChecked.checked);
					if (boxChecked.checked)
						setAttributeObj(dChk, 'checked', true);
				}
			}
			
			if (itemUpdate == "true") {
				
				if (boxChecked.checked == true)		
					SelectedUpdateCtgrsEntries.add(itemTitle);
				else
					SelectedUpdateCtgrsEntries.remove(itemTitle);
			}
			
			if (boxChecked.checked == true) {
				SelectedInstalledEntries.add(itemTitle + '$' + dependent);
			} else {
				SelectedInstalledEntries.remove(itemTitle + '$' + dependent);
			}
		}
	});
	
	IS_REMOVE_DISABLED = SelectedInstalledEntries.count <= 0;
	IS_UPDATE_DISABLED = SelectedUpdateCtgrsEntries.count <= 0;
	updateButtons();
}

/**************************************************************
 * Methods for handling closing of a dialog being shown while a server 
 * call is being made
 **************************************************************/
function handleProgressDialogClose() {
	
	if (dijit.byId('progressDialog')._alreadyInitialized == false)
		return;
	
	if (IS_OPERATION_START_FAILED == true) {
		
		doResetProgressDialog();
		return;
	}
	
	if (FEATURE_TYPE == REMOVE_FEATURE_TYPE || FEATURE_TYPE == UPDATE_FEATURE_TYPE || IS_RUN_IN_BCKGRND == true) {
		runInBckgrnd();
		return;
	}
	
	if (FEATURE_TYPE == '' || IS_TASK_IN_PROGRESS == false) {
		
		doResetProgressDialog();
		return;
	}
	
	var msg = confirmCancelInstall_msg;
	alertWarningType(msg, YES_NO);
}

function doResetProgressDialog() {
	
	hideTooltip();
	dojo.byId("chkShowStatusPane").style.visibility = 'hidden';
//	dijit.byId('progressDlgButton').setContent('');
	setContent('progressDlgButton', '');
	dojo.byId("progressbar").style.visibility = 'visible';
	setProgressStatusbar('');
}

function doHideProgressDialog() {
	
	dijit.byId('progressDialog')._alreadyInitialized = true;	// Set to false to disable hide event on click 'X'
	dijit.byId('progressDialog').hide();
}

function addProgressDlgButton(data) {
//	dijit.byId('progressDlgButton').setContent(data);
	setContent('progressDlgButton', data);
	dijit.byId('progressDialog')._alreadyInitialized = true;	// Set to false to disable hide event on click 'X'
}

function removeProgressDlgButton() {
//	dijit.byId('progressDlgButton').setContent('');
	setContent('progressDlgButton', '');
	dijit.byId('progressDialog')._alreadyInitialized = false;	// Set to false to disable hide event on click 'X'
}

var filterCounter = 0;
function addFilterOption(name) {
	var val = '';
	
	if (filterCounter > 0)
		val += ',';
	
	val += "{id: '" + filterCounter + "'," 
			+ "name: '" + name + "'," 
			+ "label: '" + name + "'}";
	
	filterCounter++;
	
	return val;
}

function initFilterOptions() {
	
	filterCounter = 0;
	
	var filterOpts = "{identifier: 'name', label: 'name', items: [";
	
	filterOpts += addFilterOption(ALL_SITES);
	filterOpts += addFilterOption(PUBLIC_SITES);
	filterOpts += addFilterOption(INTERNAL_SITES);
	filterOpts += addFilterOption(FAVORITES_SITES);
	
	filterOpts += ']}';
	
	var jsondata = dojo.fromJson(filterOpts);
	
	var filterOptsStore = new dojo.data.ItemFileReadStore({data: jsondata, jsId:"filterOptsStore"});
}

function updateSelectedAvailableContent() {
	
	var value = dijit.byId('siteSelector').attr('value');
	if (value === '') return;
	
	CURRENT_FILTER_STATE = value;
	refreshTree();
}

function siteSelected()
{
	var value = dijit.byId('siteSelector').attr('value');
	if (value === '') return;

	
	var warning = dijit.byId('filterWarning');
	if (value=="none" && warning!=null)
		warning.destroy();


	
	CURRENT_FILTER_STATE = value;
	dojo.cookie('updater.updatewar.siteSelector',value,{expires:30});
	refreshTree();
}

function updateProgressStatus() {
	
	if (TIMER) {
		clearTimeout(TIMER);
		TIMER = null;
	}
	
	// If operation is completed, no need to look for status...
	if (IS_TASK_IN_PROGRESS == false || FEATURE_TYPE_XID == '') {
		progressbar.update({progress: 100});
		runinbckgrndProgressbar.update({progress: 100});
		return;
	}
	
	dojo.xhrGet({
		url: 'state',
		handleAs: "text",
		content: {
			xid: FEATURE_TYPE_XID,
			toString: 'true',
			lang: LANG
		},
		load: function(data, ioArgs) {
			
			var mainTask = '';
			var subTask = '';
			var percent = '100';	// If no state is found, set to 100...
//			var id = '';
			
			if (data) {
				if (data.indexOf('<?xml') == 0) {
					var start = data.indexOf('<job>');
					var end = data.indexOf('</job>');
					mainTask = data.substring(start+5, end);
					
					start = data.indexOf('<message>');
					end = data.indexOf('</message>');
					subTask = data.substring(start+9, end);
					
					start = data.indexOf('<percent>');
					end = data.indexOf('</percent>');
					percent = data.substring(start+9, end);
					
//					start = data.indexOf('<id>');
//					end = data.indexOf('</id>');
//					id = data.substring(start+4, end);
				} else {
					var tokens = data.split('#');
					if (tokens.length == 4) {
						mainTask = tokens[0];
						subTask = tokens[1];
						percent = tokens[2];
//						id = tokens[3];
					}
				}
			}
			
			var progressCounter = parseInt(percent);
			if (progressCounter > 100) {
				
				progressCounter = 100;
			}
			
			if (progressCounter==-1)
			{
				progressbar.update({indeterminate: true});
				runinbckgrndProgressbar.update({indeterminate: true});
			}
			else
			{
				progressbar.update({progress: progressCounter});
				runinbckgrndProgressbar.update({progress: progressCounter});
			}
						
			// If operation is completed, no need to update message...
			if (IS_TASK_IN_PROGRESS == false || FEATURE_TYPE_XID == '') {
				progressbar.update({progress: 100});
				runinbckgrndProgressbar.update({progress: 100});
				return;
			}
			
			var status = mainTask + '<br/>';
			setProgressStatusbarWithTooltip(status, subTask);
			setRunInBckgrndProgressStatusbar(mainTask);
			
			TIMER = setTimeout("updateProgressStatus()", 1000);
		},
		error: function() {
			
			dojo.byId("chkShowStatusPane").style.visibility = 'hidden';
			
			var statusMsg = readInstallStatusFailed_msg;
			if (IS_CANCEL_INSTALL == true)
				statusMsg = readCancelStatusFailed_msg;
			else if (FEATURE_TYPE == REMOVE_FEATURE_TYPE)
				statusMsg = readRemoveStatusFailed_msg;
			else if (FEATURE_TYPE == UPDATE_FEATURE_TYPE)
				statusMsg = readUpdateStatusFailed_msg;
			
			onOperationComplete(statusMsg);
		}
	});
	
}

function onOperationComplete(statusMsg) {
	
	IS_TASK_IN_PROGRESS = false;
	IS_CANCEL_INSTALL = false;
	
	FEATURE_TYPE = '';
	FEATURE_TYPE_XID = '';
	
	refreshTree();
	setTimeout("updateInstalledFeatureGrid('false')",2000);
	
	hideTooltip();
	
	setProgressStatusbar(statusMsg);
	dojo.byId("progressbar").style.visibility = 'hidden';
	var innerHTML = '<button onclick="doHideProgressDialog()" dojoType="dijit.form.Button" type="submit">' 
			+ oklbl_msg + '</button>';
	addProgressDlgButton(innerHTML);
	
	if (IS_RUN_IN_BCKGRND == true) {
		setRunInBckgrndProgressStatusbar('');
		var wipeArgs = {
			node: "runinbckgrndPane"
		};
		dojo.fx.wipeOut(wipeArgs).play();
		IS_RUN_IN_BCKGRND = false;
		dijit.byId('progressDialog').show();
	}
}

function doCancelCurrentOperation() {
	
	IS_CANCEL_INSTALL = true;
	
	dojo.xhrGet({
		url: 'cancel',
		handleAs: "text",
		content: {
			xid: FEATURE_TYPE_XID
		},
		load: function(data, ioArgs) {
			
			/* Update Counter & progress bar */
			progressbar.update({indeterminate: false});
	        progressbar.update({ maximum: 100, progress: 0 });
	        var wipeArgs = {
        		node: "runinbckgrndPane"
        	};
        	dojo.fx.wipeOut(wipeArgs).play();
            runinbckgrndProgressbar.update({indeterminate: false});
			runinbckgrndProgressbar.update({ maximum: 100, progress: 0 });
			
			IS_RUN_IN_BCKGRND = false;
			
			var innerHTML = 
				'<button onclick="runInstallInBckgrnd()" dojoType="dijit.form.Button" type="submit">' 
				+ runinbckgrndlbl_msg + '</button>';
			
			var statusMsg = cancelInProgress_msg;
			
			addProgressDlgButton(innerHTML);
			
			setProgressStatusbar(statusMsg);
			setRunInBckgrndProgressStatusbar(statusMsg);
			
			TIMER = setTimeout("updateProgressStatus()", 1000);
			
		},
		error: function() {
			
			if (TIMER) {
				clearTimeout(TIMER);
				TIMER = null;
			}
			
			dojo.byId("chkShowStatusPane").style.visibility = 'hidden';
			
			var statusMsg = cancelStartFailed_msg;
			onOperationComplete(statusMsg);
		}
	});
}

function showStatusProgressbar() {
	
	if (IS_RUN_IN_BCKGRND == true 
		&& FEATURE_TYPE != "" && IS_TASK_IN_PROGRESS == true) {
		
		var wipeArgs = {
			node: "runinbckgrndPane"
		};
		dojo.fx.wipeOut(wipeArgs).play();
		IS_RUN_IN_BCKGRND = false;
		dijit.byId('progressDialog').show();
	}
}

function runInstallInBckgrnd() {
	
	IS_RUN_IN_BCKGRND = true;
	dijit.byId("progressDialog").hide();
}

function runInBckgrnd() {
	
	IS_RUN_IN_BCKGRND = true;
	
	var wipeArgs = {
		node: "runinbckgrndPane"
	};
	dojo.fx.wipeIn(wipeArgs).play();
	
	return;
}

function createTooltipById(tooltipId, tooltipLabel, connectId) {
	
	var currTooltip = dijit.byId(tooltipId);
	if (currTooltip == undefined) {
		
		currTooltip = new dijit.Tooltip({id: tooltipId, label: '', connectId: [connectId]});
		currTooltip.label = tooltipLabel;
	}
}

function destroyTooltipById(tooltipId) {
	
	var currTooltip = dijit.byId(tooltipId);
	if (currTooltip != undefined)
		currTooltip.destroy();
}

function toggleShowProgressStatus(chkBox) {
	
	IS_SHOW_PROGRESS_STATUS = chkBox.checked;
	if (!IS_SHOW_PROGRESS_STATUS)
		hideTooltip();
}
function toggleErrorDetails(button) {

	var errDetails = document.getElementById("errorDetails");
	errDetails.style.display="";
	
	button.setAttribute('disabled', true);
}

function setProgressStatusbarWithTooltip(statusMsg, tooltipText) {
	
	var content = statusMsg + '<br/>';
	
	if (tooltipText == '')
		hideTooltip();
	else {
		tooltipText = tooltipText.replace(/\'/g, "\\'");
		tooltipText = tooltipText.replace(/\"/g, "\\'");
		
		if (IS_SHOW_PROGRESS_STATUS)
			showTooltip(tooltipText, 'progressDlgStatus');
		else {
			statusMsg += truncateLine(tooltipText, 95);
			content = '<span onmouseover="showTooltip(\'' + tooltipText + '\', \'progressDlgStatus\');" onmouseout="hideTooltip();">' + statusMsg + '</span>';
		}
	}
	
	setProgressStatusbar(content);
}

function setProgressStatusbar(statusMsg) {
	
//	dijit.byId('statusbar').setContent(statusMsg);
	setContent('statusbar', statusMsg);
}

function setRunInBckgrndProgressStatusbar(statusMsg) {
	
//	dijit.byId('runinbckgrndStatusbar').setContent(statusMsg);
	setContent('runinbckgrndStatusbar', statusMsg);
}

function truncateLine(text, max) {
	
	if (text.length > (max + 3)) {
		text = text.substring(0, max) + '...';
	}
	
	return text;
}

function handleAddFavorite() {
	
	FAVORITE_REQUEST = 'add';
	handleFavorite();
}

function handleRemoveFavorite() {
	
	FAVORITE_REQUEST = 'remove';
	handleFavorite();
}

function handleFavorite() {
	
	var msg = warningAddFavorite_msg;
	if (FAVORITE_REQUEST == 'remove')
		msg = warningRemoveFavorite_msg;
	
	alertWarningType(msg, YES_NO);
}

function addFavorite()
{
	FAVORITE_REQUEST="add";
	alertWarningType(warningAddFavorite_msg, YES_NO);
}

function favoriteAdded(uid,href)
{
	if (uid==null)
		uid = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'uid');
	if (href==null)
		href = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'link');
	dojo.xhrPut({
		url: '../com.ibm.ut.help.common.site.FavoritesService/'+uid+'='+href,
		load: function(data,ioArgs){},
		error: function(data,ioArgs){}
	});
}

function removeFavorite()
{
	FAVORITE_REQUEST="remove";
	alertWarningType(warningAddFavorite_msg, YES_NO);
}

function favoriteRemoved()
{
	var uid = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'uid');
	var href = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'link');
	dojo.xhrDelete({
		url: '../com.ibm.ut.help.common.site.FavoritesService/'+uid+'='+href,
		load: function(data,ioArgs){
		
			var filter = dijit.byId('siteSelector').attr('value');
			if (filter=="favorites")
				refreshTree();
		},
		error: function(data,ioArgs){}
	});
}

function doHandleFavorite() {
	
	var site = getValue(POPUP_MENU_SELECTED_TREENODE.item, 'link');
	
	dojo.xhrGet({
		url: 'config',
		content: {
			op: 'Favorites',
			request: FAVORITE_REQUEST,
			uri: site
		},
		handleAs: "text",
		load: function(data, ioArgs) {
//			FAVORITE_REQUEST = '';
			refreshTree();
			},
		error: function() {
//			FAVORITE_REQUEST = '';
			refreshTree();
			}
	});
	
	FAVORITE_REQUEST = '';
}

function onClick_Category_TreeNode(checkBox) {
	
	if (checkBox.checked == true) {
		SelectedCategoriesEntries.add(checkBox.link + '$' + checkBox.label + '$' + checkBox.dependency);
		checkInstallDependency(checkBox.label, checkBox.dependency, true, checkBox.parentNode, true);
	} else {
		SelectedCategoriesEntries.remove(checkBox.link + '$' + checkBox.label + '$' + checkBox.dependency);
		checkInstallDependency(checkBox.label, checkBox.dependency, true, checkBox.parentNode, false);
	}
}

function checkInstallDependency(label, dependencyList, isOnClickCheckbox, treeNode, isChecked) {
	
	if (dependencyList == "") return "";
	
	var dependTokens = dependencyList.split(",");
	var dependencyCategoriesForInstall = "";
	
	for (var i=0; i<dependTokens.length; i++) {
		
		var isDependencyCategoryInstalled = false;
		var currDependency = dependTokens[i];
		
		var dependentNode = getDependentCategoryNode(treeNode, currDependency);
		if (dependentNode == null) continue;
		
		// Check if dependency is installed
		var checkbox = dependentNode.getCheckBox();
		if (checkbox == null)
			isDependencyCategoryInstalled = true;
		
//		var installedStoreItems = installedFeaturesStore._arrayOfAllItems;
//		for (var j=0; j<installedStoreItems.length; j++) {
//			
//			var currItem = installedStoreItems[j];
//			if(currItem.title[0] == currDependency) {
//				isDependencyCategoryInstalled = true;
//				break;
//			}
//		}
		
		if (isDependencyCategoryInstalled == false) {
			
			var isDependencyCategoryChecked = false;
			if (isOnClickCheckbox) {
				if (checkbox) {
					isDependencyCategoryChecked = checkbox.checked;
					setAttributeObj(checkbox, 'disabled', isChecked);
				}
			}
			
			if (isDependencyCategoryChecked == false) {
				
				if (isOnClickCheckbox == true && checkbox) {
					setAttributeObj(checkbox, 'checked', isChecked);
					if (isChecked)
						SelectedCategoriesEntries.add(checkbox.link + '$' + checkbox.label + '$' + checkbox.dependency);
				}
				
				if (dependencyCategoriesForInstall == "")
					dependencyCategoriesForInstall = currDependency;
				else
					dependencyCategoriesForInstall += "," + currDependency;
			}
		}
	}
	
	return dependencyCategoriesForInstall;
}

function getDependentCategoryNode(treeNode, currDependency) {
	
	if (treeNode) {
		var parent = treeNode.getParent();
		if (parent) {
			var children = parent.getChildren();
			for (var i=0; children && i<children.length; i++) {
				var node = children[i];
				if (node && node != treeNode && ('' + node.item.i.title) == currDependency)
					return node;
			}
		}
	}
	
	return null;
}

function handleDependencyCheckbox() {
	
	//Check box
//	dojo.byId(currSelectedCheckbox).checked = true;
//	SelectedEntries.add(currSelectedItemID);
}

function handleRemoveDependenciesDialogOK() {
	
	var msg = warningRemoveCategory_msg;
	alertWarningType(msg, YES_NO);
}

function checkRemoveDependency(label, dependentList, isOnClickCheckbox, isChecked) {
	
	if (dependentList == "") return "";
	
	var dependTokens = dependentList.split(",");
	var dependentCategoriesForRemove = "";
	
	for (var i=0; i<dependTokens.length; i++) {
		
		var currDependent = dependTokens[i];
		
		var isDependentExists = false;
		var checkbox = null;
		var itemTitle = '';
		var dependent = '';
		var isDependentCategoryChecked = false;
		var installedStoreItems = installedGridStore._arrayOfAllItems;
		
		for (var j=0; j<installedStoreItems.length; j++) {
			
			var currItem = installedStoreItems[j];
			itemTitle = currItem.title[0];
			dependent = currItem.dependent[0];
			
			if (itemTitle == currDependent) {
				isDependentExists = true;
				
				if (!isOnClickCheckbox) break;
				
				checkbox = dojo.byId(currItem.uid[0]);
				if (checkbox) {
					isDependentCategoryChecked = checkbox.checked;
					var value = parseInt(checkbox.value);
					if (isChecked)
						checkbox.value = 1 + value;
					else
						checkbox.value = value - 1;
					
					if (isChecked || checkbox.value == '0')
						checkbox.disabled = isChecked;
				}
				break;
			}
		}
		
		if (isDependentExists && isDependentCategoryChecked == false) {
			
			if (isOnClickCheckbox == true && checkbox) {
				checkbox.checked = isChecked;
				if (isChecked)
					SelectedInstalledEntries.add(itemTitle + '$' + dependent);
			}
			
			if (dependentCategoriesForRemove == "")
				dependentCategoriesForRemove = currDependent;
			else
				dependentCategoriesForRemove += "," + currDependent;
		}
	}
	
	return dependentCategoriesForRemove;
}
